# Tenth International Obfuscated C Code Contest

View the `index.html` web page for the given winning entry for information on how
on how to compile it and how to run the winning program.
Look at the winning source and try to figure how it does what it does!
You may then wish to look at the Author's remarks for even more details.

Use `make` to compile entries.  It is possible that on BSD or non-Unix
systems the Makefile needs to be changed.  See the Makefiles and/or `README.md`
(that are used to build the `index.html` web page) files for details.

Read over the Makefile and/or `README.md` files for compile/build issues.  Your
system may require certain changes (add or remove a library, add or remove a
`#define` i.e. the `-D` flag).

Name and address information are separated from the actual program
prior to judging.  This eliminates any chance that we would bias our
judging for/against any person or group.

This year was the first year that ANSI C was the default.  Use of
classic K&R C was allowed so long as ANSI C compilers could still
compile the entry.  If you do not have an ANSI C compiler, you may
not be able to compile the entry, sorry!


## A few notes regarding future contests:

Be sure to wait until the 1994 rules are posted before submitting entries.
Rules differ from year to year, sometimes in significant ways.

In 1994, we will retract the guideline that discouraged the use of C
constructs such as `3["curds"]`.  At one time, certain ANSI compilers did
not consider such expressions to be valid ANSI C.  Alert readers noted
that the current ANSI standard considered them to be valid.  We were
unable to find an ANSI C compiler that flagged such expressions as
errors.

Please send us comments and suggestions what we have expressed above.
Also include anything else that you would like to see in future contests.
Send such email to:

```
...!{sun,pacbell,uunet,pyramid}!hoptoad!judges
judges@toad.com
```

If you use, distribute or publish these entries in some way, please drop
us a line.  We enjoy seeing who, where and how the contest is used.


## Final Comments

**IMPORTANT NOTE**: The email addresses found above are for historical
purposes only, and should not be used today.  See
[contact.html](../contact.html) for up to date contact details
as well as details on how to provide fixes to any of the entries.
See also [the IOCCC FAQ](../faq.html) for addition information on the IOCCC.


### Credits:

We would like to thank Barbara Frezza for her role as official chef
of the contest.  Landon Curt Noll and Larry Bassel appreciated the opportunity
to serve as official taste testers.  And as usual, the food was excellent.


<!--

    Copyright © 1984-2024 by Landon Curt Noll. All Rights Reserved.

    You are free to share and adapt this file under the terms of this license:

	Creative Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)

    For more information, see:

	https://creativecommons.org/licenses/by-sa/4.0/

-->
